Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 27226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 27227)
@@ -167,19 +167,28 @@
 }
 
-void UIMachineView::setMouseIntegrationEnabled(bool bEnabled)
-{
-    if (uisession()->isMouseIntegrated() == bEnabled)
+void UIMachineView::setMouseIntegrationEnabled(bool fEnabled)
+{
+    /* Do not change anything if its already so: */
+    if (uisession()->isMouseIntegrated() == fEnabled)
         return;
 
-    if (uisession()->isMouseSupportsAbsolute())
-        captureMouse(!bEnabled, false);
-
-    /* Hiding host cursor in case we are entering mouse integration
-     * mode until it's shape is set to the guest cursor shape. */
-    if (bEnabled)
-        viewport()->setCursor(QCursor(Qt::BlankCursor));
-
-    uisession()->setMouseIntegrated(bEnabled);
-
+    /* Storing new mouse 'integrated' value: */
+    uisession()->setMouseIntegrated(fEnabled);
+
+    /* We should capture/release mouse depending on mouse 'integrated' state: */
+    captureMouse(!uisession()->isMouseIntegrated(), false /* emit signal? */);
+
+    /* Update mouse cursor shape: */
+    updateMouseCursorShape();
+
+    /* Also we switch guest mouse to the absolute mode: */
+    if (uisession()->isMouseIntegrated() &&
+        uisession()->isMouseSupportsAbsolute())
+    {
+        CMouse mouse = session().GetConsole().GetMouse();
+        mouse.PutMouseEventAbsolute(-1, -1, 0, 0, 0);
+    }
+
+    /* Notify all listeners: */
     emitMouseStateChanged();
 }
@@ -208,5 +217,4 @@
     , m_bIsHostkeyInCapture(false)
     , m_bIsMachineWindowResizeIgnored(false)
-    , m_bIsFrameBufferResizeIgnored(false)
     , m_fPassCAD(false)
 #ifdef VBOX_WITH_VIDEOHWACCEL
@@ -360,26 +368,58 @@
 }
 
-void UIMachineView::updateMouseClipping()
+void UIMachineView::updateMouseCursorShape()
+{
+    /* First of all, we should check if the host pointer should be visible.
+     * We should hide host pointer in case of:
+     * 1. mouse is 'captured' or
+     * 2. mouse is 'not captured', 'integrated', 'absolute', host pointer is hidden by the guest. */
+    if (uisession()->isMouseCaptured() ||
+        (uisession()->isMouseIntegrated() &&
+         uisession()->isMouseSupportsAbsolute() &&
+         uisession()->isHidingHostPointer()))
+    {
+        viewport()->setCursor(Qt::BlankCursor);
+    }
+
+    else
+
+    /* Otherwise we should show host pointer with guest shape assigned to it if:
+     * mouse is 'integrated', 'absolute', valid pointer shape is present. */
+    if (uisession()->isMouseIntegrated() &&
+        uisession()->isMouseSupportsAbsolute() &&
+        uisession()->isValidPointerShapePresent())
+    {
+        viewport()->setCursor(uisession()->cursor());
+    }
+
+    else
+
+    /* There could be other states covering such situations as:
+     * 1. mouse is 'not captured', 'integrated', 'not absolute' or
+     * 2. mouse is 'not captured', 'not integrated', 'absolute'.
+     * We have nothing to do with that except just unset the cursor. */
+    viewport()->unsetCursor();
+}
+
+#ifdef Q_WS_WIN32
+/* This method is actually required only because
+ * under win-host we do not really grab the mouse
+ * in case of capturing it. I have to check if its
+ * really need, may be just grabMouse() will be enought: */
+void UIMachineView::updateMouseCursorClipping()
 {
     if (uisession()->isMouseCaptured())
     {
-        viewport()->setCursor(QCursor(Qt::BlankCursor));
-#ifdef Q_WS_WIN32
         QRect r = viewport()->rect();
-        r.moveTopLeft(viewport()->mapToGlobal(QPoint (0, 0)));
+        r.moveTopLeft(viewport()->mapToGlobal(QPoint(0, 0)));
         RECT rect = { r.left(), r.top(), r.right() + 1, r.bottom() + 1 };
         ::ClipCursor(&rect);
-#endif
     }
     else
     {
-#ifdef Q_WS_WIN32
         ::ClipCursor(NULL);
-#endif
-        /* return the cursor to where it was when we captured it and show it */
-        QCursor::setPos(m_capturedMousePos);
-        viewport()->unsetCursor();
-    }
-}
+    }
+}
+#endif
 
 void UIMachineView::updateSliders()
@@ -893,6 +933,7 @@
             case QEvent::Resize:
             {
-                if (uisession()->isMouseCaptured())
-                    updateMouseClipping();
+#ifdef Q_WS_WIN32
+                updateMouseCursorClipping();
+#endif
 #ifdef VBOX_WITH_VIDEOHWACCEL
                 if (m_pFrameBuffer)
@@ -1060,23 +1101,13 @@
 void UIMachineView::sltMousePointerShapeChanged()
 {
-    /* Mouse supports 'absolute' mode? */
-    if (uisession()->isMouseSupportsAbsolute())
-    {
-        /* Should we hide pointer first of all? */
-        if (uisession()->isHidingHostPointer())
-            viewport()->setCursor(Qt::BlankCursor);
-        /* Or should we use guest pointer shape? */
-        else if (uisession()->isValidPointerShapePresent())
-            viewport()->setCursor(uisession()->cursor());
-        /* Else we have no other way except unset cursor: */
-        else
-            viewport()->unsetCursor();
-    }
+    /* Update mouse cursor: */
+    updateMouseCursorShape();
 }
 
 void UIMachineView::sltMouseCapabilityChanged()
 {
-    /* Correct the mouse capture state and reset the cursor to the default shape if necessary: */
-    if (uisession()->isMouseSupportsAbsolute())
+    /* We should release mouse if guest notified us about it supports 'absolute' mouse
+     * and mouse is in 'integrated' mode, which could be chosen from main machine menu: */
+    if (uisession()->isMouseIntegrated() && uisession()->isMouseSupportsAbsolute())
     {
         CMouse mouse = session().GetConsole().GetMouse();
@@ -1084,8 +1115,9 @@
         captureMouse(false, false);
     }
-    else
-        viewport()->unsetCursor();
-
-    /* Notify user about mouse integration state if method was called by signal: */
+
+    /* Update mouse cursor shape: */
+    updateMouseCursorShape();
+
+    /* Notify user about mouse 'absolute' state if method was called by signal: */
     if (sender()) vboxProblem().remindAboutMouseIntegration(uisession()->isMouseSupportsAbsolute());
 
@@ -1096,13 +1128,19 @@
 void UIMachineView::sltMouseCapturedStatusChanged()
 {
+#ifndef Q_WS_WIN32
     if (!uisession()->isMouseCaptured())
     {
-        /* We will just release mouse if it was released in other than that window: */
-#ifndef Q_WS_WIN32
+        /* Releasing grabbed mouse from that window: */
         viewport()->releaseMouse();
-#endif
-        /* Also we will unset cursor if mouse was released in other than that window: */
-        viewport()->unsetCursor();
-    }
+    }
+#endif
+
+#ifdef Q_WS_WIN32
+    /* Update mouse clipping: */
+    updateMouseCursorClipping();
+#endif
+
+    /* Update mouse cursor shape: */
+    updateMouseCursorShape();
 }
 
@@ -1199,7 +1237,7 @@
                 if (uisession()->isRunning() && m_bIsKeyboardCaptured)
                 {
-                    captureKbd (false);
+                    captureKbd(false);
                     if (!(uisession()->isMouseSupportsAbsolute() && uisession()->isMouseIntegrated()))
-                        captureMouse (false);
+                        captureMouse(false);
                 }
 
@@ -1316,5 +1354,5 @@
                                 qApp->processEvents();
 #endif
-                                captureMouse (m_bIsKeyboardCaptured);
+                                captureMouse(m_bIsKeyboardCaptured);
                             }
                         }
@@ -1474,25 +1512,25 @@
          */
         QRect rect = viewport()->visibleRegion().boundingRect();
-        QPoint pw = viewport()->mapToGlobal (viewport()->pos());
-        rect.translate (pw.x(), pw.y());
-
-        QRect dpRect = QApplication::desktop()->screenGeometry (viewport());
+        QPoint pw = viewport()->mapToGlobal(viewport()->pos());
+        rect.translate(pw.x(), pw.y());
+
+        QRect dpRect = QApplication::desktop()->screenGeometry(viewport());
         if (rect.intersects (dpRect))
-            rect = rect.intersect (dpRect);
+            rect = rect.intersect(dpRect);
 
         int wsafe = rect.width() / 6;
-        rect.setWidth (rect.width() - wsafe * 2);
-        rect.setLeft (rect.left() + wsafe);
+        rect.setWidth(rect.width() - wsafe * 2);
+        rect.setLeft(rect.left() + wsafe);
 
         int hsafe = rect.height() / 6;
-        rect.setWidth (rect.height() - hsafe * 2);
-        rect.setTop (rect.top() + hsafe);
-
-        if (rect.contains (aGlobalPos, true))
+        rect.setWidth(rect.height() - hsafe * 2);
+        rect.setTop(rect.top() + hsafe);
+
+        if (rect.contains(aGlobalPos, true))
             m_lastMousePos = aGlobalPos;
         else
         {
             m_lastMousePos = rect.center();
-            QCursor::setPos (m_lastMousePos);
+            QCursor::setPos(m_lastMousePos);
         }
 #else /* !Q_WS_MAC */
@@ -1506,16 +1544,16 @@
         QPoint p = aPos;
         if (aPos.x() == 0)
-            p.setX (we - 1);
+            p.setX(we - 1);
         else if (aPos.x() == we)
-            p.setX (1);
+            p.setX(1);
         if (aPos.y() == 0 )
-            p.setY (he - 1);
+            p.setY(he - 1);
         else if (aPos.y() == he)
-            p.setY (1);
+            p.setY(1);
 
         if (p != aPos)
         {
             m_lastMousePos = viewport()->mapToGlobal (p);
-            QCursor::setPos (m_lastMousePos);
+            QCursor::setPos(m_lastMousePos);
         }
         else
@@ -1539,5 +1577,5 @@
         {
             m_lastMousePos =  p;
-            QCursor::setPos (m_lastMousePos);
+            QCursor::setPos(m_lastMousePos);
         }
         else
@@ -2383,4 +2421,5 @@
 void UIMachineView::captureMouse(bool fCapture, bool fEmitSignal /* = true */)
 {
+    /* Do not change anything if its already so: */
     if (uisession()->isMouseCaptured() == fCapture)
         return;
@@ -2391,15 +2430,15 @@
         m_capturedMousePos = QCursor::pos();
 #ifdef Q_WS_WIN32
-        viewport()->setCursor(QCursor(Qt::BlankCursor));
         /* Move the mouse to the center of the visible area: */
-        QCursor::setPos(mapToGlobal(visibleRegion().boundingRect().center()));
-        m_lastMousePos = QCursor::pos();
+        m_lastMousePos = mapToGlobal(visibleRegion().boundingRect().center());
+        QCursor::setPos(m_lastMousePos);
 #elif defined (Q_WS_MAC)
         /* Move the mouse to the center of the visible area: */
-        m_lastMousePos = mapToGlobal (visibleRegion().boundingRect().center());
+        m_lastMousePos = mapToGlobal(visibleRegion().boundingRect().center());
         QCursor::setPos(m_lastMousePos);
         /* Grab all mouse events: */
         viewport()->grabMouse();
 #else
+        /* Grab all mouse events: */
         viewport()->grabMouse();
         m_lastMousePos = QCursor::pos();
@@ -2408,16 +2447,16 @@
     else
     {
-#ifndef Q_WS_WIN32
-        viewport()->releaseMouse();
-#endif
-        /* Release mouse buttons: */
-        CMouse mouse = session().GetConsole().GetMouse();
-        mouse.PutMouseEvent(0, 0, 0, 0, 0);
-    }
-
+        /* Return the cursor to where it was when we captured it: */
+        QCursor::setPos(m_capturedMousePos);
+    }
+
+    /* Updating guest mouse: */
+    CMouse mouse = session().GetConsole().GetMouse();
+    mouse.PutMouseEvent(0, 0, 0, 0, 0);
+
+    /* Storing new mouse 'captured' value: */
     uisession()->setMouseCaptured(fCapture);
 
-    updateMouseClipping();
-
+    /* Emit signal if required: */
     if (fEmitSignal)
         emitMouseStateChanged();
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 27226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 27227)
@@ -110,5 +110,4 @@
     bool isHostKeyPressed() const { return m_bIsHostkeyPressed; }
     bool isMachineWindowResizeIgnored() const { return m_bIsMachineWindowResizeIgnored; }
-    bool isFrameBufferResizeIgnored() const { return m_bIsFrameBufferResizeIgnored; }
     const QPixmap& pauseShot() const { return m_pauseShot; }
     QSize storedConsoleSize() const { return m_storedConsoleSize; }
@@ -119,9 +118,11 @@
     void storeConsoleSize(int iWidth, int iHeight);
     void setMachineWindowResizeIgnored(bool fIgnore = true) { m_bIsMachineWindowResizeIgnored = fIgnore; }
-    void setFrameBufferResizeIgnored(bool fIgnore = true) { m_bIsFrameBufferResizeIgnored = fIgnore; }
 
     /* Protected helpers: */
     void calculateDesktopGeometry();
-    void updateMouseClipping();
+    void updateMouseCursorShape();
+#ifdef Q_WS_WIN32
+    void updateMouseCursorClipping();
+#endif
     void updateSliders();
 
@@ -237,5 +238,4 @@
     bool m_bIsHostkeyInCapture : 1;
     bool m_bIsMachineWindowResizeIgnored : 1;
-    bool m_bIsFrameBufferResizeIgnored : 1;
     bool m_fPassCAD;
 #ifdef VBOX_WITH_VIDEOHWACCEL
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 27226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 27227)
@@ -555,5 +555,5 @@
     , m_fIsMouseIntegrated(true)
     , m_fIsValidPointerShapePresent(false)
-    , m_fIsHideHostPointer(true)
+    , m_fIsHidingHostPointer(true)
 {
     /* Register console callback: */
@@ -667,5 +667,5 @@
             {
                 /* We are ignoring visibility flag: */
-                m_fIsHideHostPointer = false;
+                m_fIsHidingHostPointer = false;
 
                 /* And updating current cursor shape: */
@@ -678,5 +678,5 @@
             {
                 /* Remember if we should hide the cursor: */
-                m_fIsHideHostPointer = !pConsoleEvent->isVisible();
+                m_fIsHidingHostPointer = !pConsoleEvent->isVisible();
             }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 27226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 27227)
@@ -118,5 +118,5 @@
     bool isMouseIntegrated() const { return m_fIsMouseIntegrated; }
     bool isValidPointerShapePresent() const { return m_fIsValidPointerShapePresent; }
-    bool isHidingHostPointer() const { return m_fIsMouseCaptured || (m_fIsMouseSupportsAbsolute && m_fIsHideHostPointer); }
+    bool isHidingHostPointer() const { return m_fIsHidingHostPointer; }
 
     /* Common setters: */
@@ -224,5 +224,5 @@
     bool m_fIsMouseIntegrated : 1;
     bool m_fIsValidPointerShapePresent : 1;
-    bool m_fIsHideHostPointer : 1;
+    bool m_fIsHidingHostPointer : 1;
 
     /* Friend classes: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.cpp	(revision 27226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.cpp	(revision 27227)
@@ -189,18 +189,9 @@
 #endif /* Q_WS_MAC */
 
-            /* Unfortunately restoreOverrideCursor() is broken in Qt 4.4.0 if WA_PaintOnScreen widgets are present.
-             * This is the case on linux with SDL. As workaround we save/restore the arrow cursor manually.
-             * See http://trolltech.com/developer/task-tracker/index_html?id=206165&method=entry for details.
-             * Moreover the current cursor, which could be set by the guest, should be restored after resize: */
-            if (uisession()->isValidPointerShapePresent())
-                viewport()->setCursor(uisession()->cursor());
-            else if (uisession()->isHidingHostPointer())
-                viewport()->setCursor(Qt::BlankCursor);
-            /* This event appears in case of guest video was changed for somehow even without video resolution change.
-             * In this last case the host VM window will not be resized according this event and the host mouse cursor
-             * which was unset to default here will not be hidden in capture state. So it is necessary to perform
-             * updateMouseClipping() for the guest resize event if the mouse cursor was captured: */
-            if (uisession()->isMouseCaptured())
-                updateMouseClipping();
+            /* Update mouse cursor shape: */
+            updateMouseCursorShape();
+#ifdef Q_WS_WIN32
+            updateMouseCursorClipping();
+#endif
 
             /* May be we have to restrict minimum size? */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.cpp	(revision 27226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.cpp	(revision 27227)
@@ -144,52 +144,27 @@
         case VBoxDefs::ResizeEventType:
         {
-            /* Some situations require initial VGA Resize Request
-             * to be ignored at all, leaving previous framebuffer,
-             * machine view and machine window sizes preserved: */
+            /* Some situations require framebuffer resize events to be ignored,
+             * leaving machine window & machine view & framebuffer sizes preserved: */
             if (uisession()->isGuestResizeIgnored())
                 return true;
 
+            /* We are starting to perform machine view resize: */
             bool oldIgnoreMainwndResize = isMachineWindowResizeIgnored();
             setMachineWindowResizeIgnored(true);
 
+            /* Get guest resize-event: */
             UIResizeEvent *pResizeEvent = static_cast<UIResizeEvent*>(pEvent);
+
+            /* Perform framebuffer resize: */
+            frameBuffer()->resizeEvent(pResizeEvent);
+
+            /* Reapply maximum size restriction for machine view: */
+            setMaximumSize(sizeHint());
 
             /* Store the new size to prevent unwanted resize hints being sent back. */
             storeConsoleSize(pResizeEvent->width(), pResizeEvent->height());
 
-            /* Unfortunately restoreOverrideCursor() is broken in Qt 4.4.0 if WA_PaintOnScreen widgets are present.
-             * This is the case on linux with SDL. As workaround we save/restore the arrow cursor manually.
-             * See http://trolltech.com/developer/task-tracker/index_html?id=206165&method=entry for details.
-             * Moreover the current cursor, which could be set by the guest, should be restored after resize: */
-            QCursor cursor;
-            if (uisession()->isHidingHostPointer())
-                cursor = QCursor(Qt::BlankCursor);
-            else
-                cursor = viewport()->cursor();
-            frameBuffer()->resizeEvent(pResizeEvent);
-            viewport()->setCursor(cursor);
-
-#ifdef Q_WS_MAC
-            // TODO_NEW_CORE
-//            mDockIconPreview->setOriginalSize(pResizeEvent->width(), pResizeEvent->height());
-#endif /* Q_WS_MAC */
-
-            /* This event appears in case of guest video was changed for somehow even without video resolution change.
-             * In this last case the host VM window will not be resized according this event and the host mouse cursor
-             * which was unset to default here will not be hidden in capture state. So it is necessary to perform
-             * updateMouseClipping() for the guest resize event if the mouse cursor was captured: */
-            if (uisession()->isMouseCaptured())
-                updateMouseClipping();
-
-            /* Apply maximum size restriction: */
-            setMaximumSize(sizeHint());
-
-            /* May be we have to restrict minimum size? */
-            maybeRestrictMinimumSize();
-
             /* Resize the guest canvas: */
-            if (!isFrameBufferResizeIgnored())
-                resize(pResizeEvent->width(), pResizeEvent->height());
-            updateSliders();
+            resize(pResizeEvent->width(), pResizeEvent->height());
 
             /* Let our toplevel widget calculate its sizeHint properly. */
@@ -203,17 +178,32 @@
 #endif /* Q_WS_X11 */
 
-            if (!isFrameBufferResizeIgnored())
-                normalizeGeometry(true /* adjustPosition */);
+#ifdef Q_WS_MAC
+            // TODO_NEW_CORE
+//            mDockIconPreview->setOriginalSize(pResizeEvent->width(), pResizeEvent->height());
+#endif /* Q_WS_MAC */
+
+            /* Update mouse cursor shape: */
+            updateMouseCursorShape();
+#ifdef Q_WS_WIN32
+            updateMouseCursorClipping();
+#endif
+
+            /* May be we have to restrict minimum size? */
+            maybeRestrictMinimumSize();
+
+            /* Update machine view sliders: */
+            updateSliders();
+
+            /* Normalize geometry: */
+            normalizeGeometry(true /* adjustPosition */);
 
             /* Report to the VM thread that we finished resizing */
             session().GetConsole().GetDisplay().ResizeCompleted(screenId());
 
+            /* We are finishing to perform machine view resize: */
             setMachineWindowResizeIgnored(oldIgnoreMainwndResize);
 
             /* Make sure that all posted signals are processed: */
             qApp->processEvents();
-
-            /* Emit a signal about guest was resized: */
-            emit resizeHintDone();
 
             /* We also recalculate the desktop geometry if this is determined
@@ -222,7 +212,6 @@
             calculateDesktopGeometry();
 
-            /* Enable frame-buffer resize watching: */
-            if (isFrameBufferResizeIgnored())
-                setFrameBufferResizeIgnored(false);
+            /* Emit a signal about guest was resized: */
+            emit resizeHintDone();
 
             return true;
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.cpp	(revision 27226)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.cpp	(revision 27227)
@@ -188,18 +188,9 @@
 #endif /* Q_WS_MAC */
 
-            /* Unfortunately restoreOverrideCursor() is broken in Qt 4.4.0 if WA_PaintOnScreen widgets are present.
-             * This is the case on linux with SDL. As workaround we save/restore the arrow cursor manually.
-             * See http://trolltech.com/developer/task-tracker/index_html?id=206165&method=entry for details.
-             * Moreover the current cursor, which could be set by the guest, should be restored after resize: */
-            if (uisession()->isValidPointerShapePresent())
-                viewport()->setCursor(uisession()->cursor());
-            else if (uisession()->isHidingHostPointer())
-                viewport()->setCursor(Qt::BlankCursor);
-            /* This event appears in case of guest video was changed for somehow even without video resolution change.
-             * In this last case the host VM window will not be resized according this event and the host mouse cursor
-             * which was unset to default here will not be hidden in capture state. So it is necessary to perform
-             * updateMouseClipping() for the guest resize event if the mouse cursor was captured: */
-            if (uisession()->isMouseCaptured())
-                updateMouseClipping();
+            /* Update mouse cursor shape: */
+            updateMouseCursorShape();
+#ifdef Q_WS_WIN32
+            updateMouseCursorClipping();
+#endif
 
             /* Report to the VM thread that we finished resizing: */